/*
 * Simple program, that chiffres a specified file
 * using a specified key into an output file.
 * To dechiffre the encryptet file you use the
 * same program specifying the same key.
 *
 * usage: ./sxor <KEY> <INPUTFILE> <OUTPUTFILE>
 *
 * by LexLufix
 * LexLufix@gmx.net
 *
 * */

#include <stdio.h>

void banner();

int main(int argc, char **argv) {
		FILE *fi, *fo;
		char *cp;
		int c, count;
		
		banner();
		if (argc != 4) {
				printf("usage: %s <KEY> <INPUTFILE> <OUTPUTFILE>\n\n", argv[0]);
				exit(1);
		}
	
		if ((cp = argv[1]) && *cp!='\0') {
				if ((fi = fopen(argv[2], "rb")) != NULL) {
						printf("opened inputfile '%s' for reading\n", argv[2]);
						if ((fo = fopen(argv[3], "wb")) != NULL) {
								printf("opened outputfile '%s' for writing\n", argv[3]);
								count = 0;
								while ((c = getc(fi)) != EOF) {
										if (!*cp) cp = argv[1];
										c ^= *(cp++);
										putc(c, fo);
										putc('.', stdout);
										count++;
								}
						}
						fclose(fo);
						printf("\noutputfile '%s' closed.\n", argv[3]);
				}
				fclose(fi);
				printf("inputfile '%s' closed.\n", argv[2]);
				printf("%d bytes chiffred from %s to %s using key '%s'\n",
								count, argv[2], argv[3], argv[1]);
		}
		
		printf("\n\nhope it helped you...\n");
		printf("by LexLufix\n");
		printf("LexLufix@gmx.net | http://lex.homelinux.net\n\n");
		return 0;
}

void banner() {
		printf("\nSimple program that chiffres a file using a key\n");
		printf("with XORing the bytes with the key. To encrypt again\n");
		printf("use same program and same keystring.\n\n");
		
		return;
}
